import { ElementRef, EventEmitter, OnDestroy, QueryList } from '@angular/core';
import { BehaviorSubject, Observable, Subject } from 'rxjs';
import { BsCalendarMonthService } from '../../../../services/calendar-month/calendar-month.service';
import { DragOperation } from '../../interfaces/drag-operation';
import { SchedulerEvent } from '../../interfaces/scheduler-event';
import { SchedulerEventPart } from '../../interfaces/scheduler-event-part';
import { SchedulerEventWithParts } from '../../interfaces/scheduler-event-with-parts';
import { TimeSlot } from '../../interfaces/time-slot';
import * as i0 from "@angular/core";
export declare class BsSchedulerComponent implements OnDestroy {
    private calendarMonthService;
    constructor(calendarMonthService: BsCalendarMonthService);
    events$: BehaviorSubject<SchedulerEvent[]>;
    eventParts$: Observable<SchedulerEventWithParts[]>;
    eventPartsForThisWeek$: BehaviorSubject<SchedulerEventPart[]>;
    currentWeek$: BehaviorSubject<Date>;
    daysOfWeek$: Observable<Date[]>;
    timeSlotDuration$: BehaviorSubject<number>;
    timeSlots$: Observable<TimeSlot[][]>;
    mouseState$: BehaviorSubject<boolean>;
    hoveredTimeSlot$: BehaviorSubject<TimeSlot | null>;
    destroyed$: Subject<unknown>;
    timeSlotElements: QueryList<ElementRef<HTMLDivElement>>;
    unitHeight$: BehaviorSubject<number>;
    unitHeightChange: EventEmitter<number>;
    get unitHeight(): number;
    set unitHeight(value: number);
    private dateEquals;
    private addDays;
    onPreviousWeek(): void;
    onNextWeek(): void;
    operation: DragOperation | null;
    dragStartTimeslot: TimeSlot | null;
    onCreateEvent(ev: MouseEvent, slot: TimeSlot): void;
    onStartDragEvent(eventPart: SchedulerEventPart, ev: MouseEvent): void;
    private getHoveredTimeslot;
    onMousemove(ev: MouseEvent): void;
    onMouseUp(ev: MouseEvent): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsSchedulerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsSchedulerComponent, "bs-scheduler", never, { "unitHeight": "unitHeight"; }, { "unitHeightChange": "unitHeightChange"; }, never, never>;
}
